#ifndef __ENTITY_COPY_H__
#define __ENTITY_COPY_H__	20250508

#ifndef __DCL_OBJECT_H__
#include <dcl/Object.h>
#endif
#ifndef __DCL_SQL_H__
#include <dcl/SQL.h>
#endif
#ifndef __DCL_ARRAY_T_H__
#include <dcl/ArrayT.h>
#endif

__DCL_BEGIN_NAMESPACE

class MainArguments;

struct DatabaseHelper
{
	const wchar_t* driverName;
	const wchar_t* selectTableList;
	const wchar_t* truncateTable;
};

struct Entity
{
	String name;
	String columns;
	String toName;
	String toColumns;

	Entity() {}
	Entity(const Entity& _s);
	Entity& operator = (const Entity& _s);
	String toString();
};

class EntityCopy
{
public:
	EntityCopy(const MainArguments& _args,
		const String& _srcDriver, const String& _dstDriver)
		__DCL_THROWS1(SQLDriverException*);

	bool initialize()
		__DCL_THROWS1(SQLException*);

	void doIt();

protected:
	const MainArguments& __args;
	SQLConnection	__srcConn;
	SQLConnection	__dstConn;

	const DatabaseHelper* __srcHelper;
	const DatabaseHelper* __dstHelper;

	Array<Entity>	__entities;

	String getSelectSQL(const Entity& _e);
	String getInsertSQL(const Entity& _e, const SQLFields& _fields);
	String getTruncateSQL(const Entity& _e);

	void translateFieldValue(SQLField& _field, SQLParam& _param)
		__DCL_THROWS1(SQLException*);

	void copyEntity(const Entity& _e)
		__DCL_THROWS1(SQLException*);

	String __lineRuler;
	String __lineIndent;
};

__DCL_END_NAMESPACE

#endif	// __ENTITY_COPY_H__
