/*
 * 2025-05-10 토
 */

/*
DROP TABLE AGENTS;
DROP TABLE APPINFOS;
DROP TABLE BANKS;
DROP TABLE CATEGORIES;
DROP TABLE DUAL;
DROP TABLE GRADES;
DROP TABLE INCOME_TAXES;
DROP TABLE META_SPON;
DROP TABLE ORDERS;
DROP TABLE ORDER_DETAILS;
DROP TABLE ORDER_RECEIPTS;
DROP TABLE ORDER_TYPES;
DROP TABLE PAYKINDS;
DROP TABLE PAYS;
DROP TABLE PAYS_MASTERS;
DROP TABLE PRODUCTS;
DROP TABLE PUCS;
DROP TABLE RECEIPTS;
DROP TABLE TEMP_CHILDREN_SPON;
DROP TABLE TEMP_INVALID_SPON;
DROP TABLE TEMP_PAY_5;
DROP TABLE TEMP_PAY_5_1;
DROP TABLE TEMP_SPON_VISITED;
DROP TABLE TEMP_THIS_VISITED;
DROP TABLE TEMP_VISITED_AGENT;
DROP TABLE USERS;
DROP TABLE ZIPCODES;

DROP DOMAIN CURRENCY;
*/

CREATE DOMAIN CURRENCY AS DECIMAL(18, 2) DEFAULT 0.0 NOT NULL;

CREATE TABLE 
    AGENTS (
        AGENT_ID INTEGER NOT NULL,
        SPONSOR_ID INTEGER NOT NULL,
        INTRODUCER_ID INTEGER NOT NULL,
        NAME_K VARCHAR(10) NOT NULL,
        NAME_ALIAS VARCHAR(10),
        JUMIN_NUMBER CHAR(13) NOT NULL,
        TEL VARCHAR(40),
        EMAIL VARCHAR(40),
        ZIPCODE VARCHAR(6),
        ADDR VARCHAR(100),
        ADDR_FINAL VARCHAR(60),
        B_REGIST_NO VARCHAR(10),
        FIRM_NAME VARCHAR(20),
        DEPOSIT_BANK VARCHAR(20),
        DEPOSIT_ACCOUNT VARCHAR(20),
        DEPOSIT_OWNER VARCHAR(20),
        REGIST_DATE DATE NOT NULL,
        UNREGIST_DATE DATE,
        GRADE_ID SMALLINT NOT NULL,
        GRADE_DATE DATE NOT NULL,
        M_GRADE_ID SMALLINT NOT NULL,
        M_GRADE_DATE DATE NOT NULL,
        PUC_ID SMALLINT NOT NULL,
        REMARKS VARCHAR(255),
        UPDATE_DATETIME TIMESTAMP NOT NULL,
        UPDATE_USER_ID SMALLINT NOT NULL,
        RC_DATETIME TIMESTAMP
    );

CREATE TABLE
    APPINFOS (
        PROPERTY_NAME VARCHAR(40) NOT NULL,
        PROPERTY_VALUE VARCHAR(255) DEFAULT '' NOT NULL,
        REMARKS VARCHAR(255)
    );

CREATE TABLE
    BANKS (
        BANK_CODE CHAR(2) NOT NULL,
        BANK_NAME VARCHAR(20) NOT NULL,
        UI_PRIORITY SMALLINT NOT NULL,
        UI_ACTIVITY CHAR(1) DEFAULT 'T' NOT NULL
    );

CREATE TABLE
    CATEGORIES (
        CATEGORY_ID SMALLINT NOT NULL,
        CATEGORY_NAME VARCHAR(40),
        REMARKS VARCHAR(255),
        REGIST_DATE DATE
    );

CREATE TABLE
    DUAL (X CHAR(1) NOT NULL);

CREATE TABLE
    GRADES (
        GRADE_ID SMALLINT NOT NULL,
        GRADE_NAME VARCHAR(20) NOT NULL,
        REMARKS VARCHAR(255)
    );

CREATE TABLE
    INCOME_TAXES (
        ID INTEGER NOT NULL,
        AGENT_ID INTEGER NOT NULL,
        PAYDAY DATE NOT NULL,
        AMOUNT CURRENCY NOT NULL,
        TAX_RATES FLOAT NOT NULL,
        INCOME_TAX CURRENCY NOT NULL,
        RESIDENCE_TAX CURRENCY NOT NULL,
        PROCESS_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP NOT NULL
    );

CREATE TABLE
    META_SPON (
        PARENT_ID INTEGER NOT NULL,
        CHILD_ID INTEGER NOT NULL,
        DISPLACEMENT INTEGER NOT NULL,
        TAG INTEGER DEFAULT 0 NOT NULL,
        TAG_SET_DATETIME TIMESTAMP
    );

CREATE TABLE
    ORDERS (
        ORDER_ID INTEGER NOT NULL,
        AGENT_ID INTEGER NOT NULL,
        PUC_ID SMALLINT NOT NULL,
        ORDER_TYPE_ID SMALLINT DEFAULT 1 NOT NULL,
        ORDER_DATE DATE NOT NULL,
        SALE_DATE DATE NOT NULL,
        SHIP_NAME VARCHAR(10),
        SHIP_ZIPCODE VARCHAR(6),
        SHIP_ADDR VARCHAR(100),
        SHIP_ADDR_FINAL VARCHAR(60),
        SHIP_TEL VARCHAR(20),
        UPDATE_DATETIME TIMESTAMP NOT NULL,
        UPDATE_USER_ID SMALLINT NOT NULL,
        RC_DATETIME TIMESTAMP
    );

CREATE TABLE
    ORDER_DETAILS (
        ORDER_ID INTEGER NOT NULL,
        PRODUCT_ID SMALLINT NOT NULL,
        UNIT_PRICE CURRENCY NOT NULL,
        UNIT_PV CURRENCY NOT NULL,
        QUANTITY INTEGER NOT NULL,
        RC_DATETIME TIMESTAMP
    );

CREATE TABLE
    ORDER_RECEIPTS (
        ORDER_ID INTEGER NOT NULL,
        SERIAL_NO SMALLINT NOT NULL,
        RECEIPT_DATE DATE NOT NULL,
        RECEIPT_ID SMALLINT NOT NULL,
        AMOUNT CURRENCY NOT NULL,
        CARD_OWNER VARCHAR(10),
        CARD_NUMBER VARCHAR(20),
        CARD_APPROVAL VARCHAR(20)
    );

CREATE TABLE
    ORDER_TYPES (
        ORDER_TYPE_ID SMALLINT NOT NULL,
        ORDER_TYPE_NAME VARCHAR(20),
        UI_PRIORITY SMALLINT NOT NULL
    );

CREATE TABLE
    PAYKINDS (
        PAYKIND_ID SMALLINT NOT NULL,
        PAYKIND_NAME VARCHAR(40) NOT NULL,
        REMARKS VARCHAR(255)
    );

CREATE TABLE
    PAYS (
        PAYS_MASTER_ID INTEGER NOT NULL,
        AGENT_ID INTEGER NOT NULL,
        PAYKIND_ID SMALLINT NOT NULL,
        GRADE_ID SMALLINT NOT NULL,
        AMOUNT CURRENCY NOT NULL,
        SAVEUP CURRENCY NOT NULL,
        TAXES CURRENCY NOT NULL,
        PAY CURRENCY NOT NULL
    );

CREATE TABLE
    PAYS_MASTERS (
        PAYS_MASTER_ID INTEGER NOT NULL,
        PROCESS_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP NOT NULL,
        PROCESS_TIME_END TIMESTAMP,
        SALES_EQUAL_FROM DATE NOT NULL,
        SALES_EQUAL_TO DATE NOT NULL,
        PAYDAY DATE NOT NULL,
        SUM_OF_SALES CURRENCY NOT NULL,
        CALC_TYPE VARCHAR(20) NOT NULL,
        REMARKS VARCHAR(255)
    );

CREATE TABLE
    PRODUCTS (
        PRODUCT_ID SMALLINT NOT NULL,
        PRODUCT_NAME VARCHAR(40),
        CATEGORY_ID SMALLINT NOT NULL,
        UNIT VARCHAR(20),
        UNIT_PRICE CURRENCY,
        UNIT_PV CURRENCY,
        UI_PRIORITY SMALLINT NOT NULL,
        UI_ACTIVITY CHAR(1) DEFAULT 'T' NOT NULL,
        REMARKS VARCHAR(255),
        REGIST_DATE DATE DEFAULT CURRENT_DATE NOT NULL
    );

CREATE TABLE
    PUCS (
        PUC_ID SMALLINT NOT NULL,
        PUC_NAME VARCHAR(20) NOT NULL,
        MANAGER VARCHAR(10),
        EMAIL VARCHAR(20),
        TEL VARCHAR(40),
        FAX VARCHAR(40),
        ZIPCODE VARCHAR(6),
        ADDR VARCHAR(100),
        ADDR_FINAL VARCHAR(60),
        REGIST_DATE DATE NOT NULL,
        REMARKS VARCHAR(255)
    );

CREATE TABLE
    RECEIPTS (
        RECEIPT_ID SMALLINT NOT NULL,
        RECEIPT_NAME VARCHAR(20),
        UI_PRIORITY SMALLINT NOT NULL,
        UI_ACTIVITY CHAR(1) DEFAULT 'T' NOT NULL
    );

CREATE TABLE
    TEMP_CHILDREN_SPON (
        SEQ INTEGER NOT NULL,
        AGENT_ID INTEGER NOT NULL,
        DEPTH INTEGER NOT NULL
    );

CREATE TABLE
    TEMP_INVALID_SPON (
        AGENT_ID INTEGER NOT NULL,
        SEQ INTEGER NOT NULL,
        SPONSOR_ID INTEGER NOT NULL
    );

CREATE TABLE
    TEMP_PAY_5 (
        AGENT_ID INTEGER NOT NULL,
        AMOUNT CURRENCY DEFAULT 0. NOT NULL
    );

CREATE TABLE
    TEMP_PAY_5_1 (
        AGENT_ID INTEGER NOT NULL,
        AMOUNT CURRENCY DEFAULT 0. NOT NULL
    );

CREATE TABLE
    TEMP_SPON_VISITED (
        SEQ INTEGER NOT NULL,
        AGENT_ID INTEGER NOT NULL,
        SPONSOR_ID INTEGER NOT NULL
    );

CREATE TABLE
    TEMP_THIS_VISITED (SEQ INTEGER NOT NULL, AGENT_ID INTEGER NOT NULL);

CREATE TABLE
    TEMP_VISITED_AGENT (
        AGENT_ID INTEGER NOT NULL
    );

CREATE TABLE
    USERS (
        USER_ID SMALLINT NOT NULL,
        USER_NAME VARCHAR(20) NOT NULL,
        USER_PASSWORD VARCHAR(20),
        PERM_LEVEL SMALLINT DEFAULT 1 NOT NULL
    );

CREATE TABLE
    ZIPCODES (
        ZIPCODE CHAR(6) NOT NULL,
        SIDO VARCHAR(20) NOT NULL,
        GUGUN VARCHAR(40) NOT NULL,
        DONG VARCHAR(60) NOT NULL,
        BUNJIHO VARCHAR(60),
        UPDATE_DATE DATE NOT NULL
    );