/*
 * 2025-05-10 토
 */

 /*
ALTER TABLE AGENTS DROP CONSTRAINT AGENTS_PK;
ALTER TABLE APPINFOS DROP CONSTRAINT APPINFOS_PK;
ALTER TABLE BANKS DROP CONSTRAINT BANKS_PK;
ALTER TABLE CATEGORIES DROP CONSTRAINT CATEGORIES_PK;
ALTER TABLE GRADES DROP CONSTRAINT GRADES_PK;
ALTER TABLE INCOME_TAXES DROP CONSTRAINT INCOME_TAXES_PK;
ALTER TABLE META_SPON DROP CONSTRAINT META_SPON_PK;
ALTER TABLE ORDERS DROP CONSTRAINT ORDERS_PK;
ALTER TABLE ORDER_DETAILS DROP CONSTRAINT ORDER_DETAILS_PK;
ALTER TABLE ORDER_RECEIPTS DROP CONSTRAINT ORDER_RECEIPTS_PK;
ALTER TABLE ORDER_TYPES DROP CONSTRAINT ORDER_TYPES_PK;
ALTER TABLE PAYKINDS DROP CONSTRAINT PAYKINDS_PK;
ALTER TABLE PAYS DROP CONSTRAINT PAYS_PK;
ALTER TABLE PAYS_MASTERS DROP CONSTRAINT PAYS_MASTERS_PK;
ALTER TABLE PRODUCTS DROP CONSTRAINT PRODUCTS_PK;
ALTER TABLE PUCS DROP CONSTRAINT PUCS_PK;
ALTER TABLE RECEIPTS DROP CONSTRAINT RECEIPTS_PK;
ALTER TABLE TEMP_INVALID_SPON DROP CONSTRAINT TEMP_INVALID_SPON_PK;
ALTER TABLE TEMP_PAY_5 DROP CONSTRAINT TEMP_PAY_5_PK;
ALTER TABLE TEMP_VISITED_AGENT DROP CONSTRAINT TEMP_VISITED_AGENT_PK;
ALTER TABLE USERS DROP CONSTRAINT USERS_PK;

ALTER TABLE BANKS DROP CONSTRAINT BANKS_UK_BANK_NAME;
ALTER TABLE USERS DROP CONSTRAINT USERS_UK_USER_NAME;
 */

ALTER TABLE AGENTS ADD CONSTRAINT AGENTS_PK PRIMARY KEY (AGENT_ID);
ALTER TABLE APPINFOS ADD CONSTRAINT APPINFOS_PK PRIMARY KEY (PROPERTY_NAME);
ALTER TABLE BANKS ADD CONSTRAINT BANKS_PK PRIMARY KEY (BANK_CODE);
ALTER TABLE CATEGORIES ADD CONSTRAINT CATEGORIES_PK PRIMARY KEY (CATEGORY_ID);
ALTER TABLE GRADES ADD CONSTRAINT GRADES_PK PRIMARY KEY (GRADE_ID);
ALTER TABLE INCOME_TAXES ADD CONSTRAINT INCOME_TAXES_PK PRIMARY KEY (ID, AGENT_ID);
ALTER TABLE META_SPON ADD CONSTRAINT META_SPON_PK PRIMARY KEY (PARENT_ID, CHILD_ID, DISPLACEMENT);
ALTER TABLE ORDERS ADD CONSTRAINT ORDERS_PK PRIMARY KEY (ORDER_ID);
ALTER TABLE ORDER_DETAILS ADD CONSTRAINT ORDER_DETAILS_PK PRIMARY KEY (ORDER_ID, PRODUCT_ID);
ALTER TABLE ORDER_RECEIPTS ADD CONSTRAINT ORDER_RECEIPTS_PK PRIMARY KEY (ORDER_ID, SERIAL_NO);
ALTER TABLE ORDER_TYPES ADD CONSTRAINT ORDER_TYPES_PK PRIMARY KEY (ORDER_TYPE_ID);
ALTER TABLE PAYKINDS ADD CONSTRAINT PAYKINDS_PK PRIMARY KEY (PAYKIND_ID);
ALTER TABLE PAYS ADD CONSTRAINT PAYS_PK PRIMARY KEY (PAYS_MASTER_ID, AGENT_ID, PAYKIND_ID);
ALTER TABLE PAYS_MASTERS ADD CONSTRAINT PAYS_MASTERS_PK PRIMARY KEY (PAYS_MASTER_ID);
ALTER TABLE PRODUCTS ADD CONSTRAINT PRODUCTS_PK PRIMARY KEY (PRODUCT_ID);
ALTER TABLE PUCS ADD CONSTRAINT PUCS_PK PRIMARY KEY (PUC_ID);
ALTER TABLE RECEIPTS ADD CONSTRAINT RECEIPTS_PK PRIMARY KEY (RECEIPT_ID);
ALTER TABLE TEMP_INVALID_SPON ADD CONSTRAINT TEMP_INVALID_SPON_PK PRIMARY KEY (AGENT_ID, SEQ);
ALTER TABLE TEMP_PAY_5 ADD CONSTRAINT TEMP_PAY_5_PK PRIMARY KEY (AGENT_ID);
ALTER TABLE TEMP_VISITED_AGENT ADD CONSTRAINT TEMP_VISITED_AGENT_PK PRIMARY KEY (AGENT_ID);
ALTER TABLE USERS ADD CONSTRAINT USERS_PK PRIMARY KEY (USER_ID);

ALTER TABLE BANKS ADD CONSTRAINT BANKS_UK_BANK_NAME UNIQUE (BANK_NAME);
ALTER TABLE USERS ADD CONSTRAINT USERS_UK_USER_NAME UNIQUE (USER_NAME);
