SET SQL DIALECT 3;

/* CREATE DATABASE '127.0.0.1/gds_db:D:\Opt\InterBase\Data\TIMETABLE.IB' USER 'SYSDBA' password 'Enter_Password_here' PAGE_SIZE 4096
; */
COMMIT;
/*CONNECT '127.0.0.1/gds_db:D:\Opt\InterBase\Data\TIMETABLE.IB' USER 'SYSDSO' PASSWORD 'Enter_Password_here'; */
/* ALTER DATABASE SET SYSTEM ENCRYPTION PASSWORD 'Enter_Password_here';*/
COMMIT;
/*CONNECT '127.0.0.1/gds_db:D:\Opt\InterBase\Data\TIMETABLE.IB' USER 'SYSDBA' PASSWORD 'Enter_Password_here'; */
/* Domain definitions */
CREATE DOMAIN BOOL AS SMALLINT
	 DEFAULT 0;
CREATE DOMAIN LONGLONG AS DECIMAL(18, 0);

/* Table: COURSE, Owner: SYSDBA */
CREATE TABLE COURSE 
(
        ID	INTEGER NOT NULL,
        NAME	VARCHAR(40) NOT NULL,
        BEGIN_DATE	DATE NOT NULL,
        END_DATE	DATE NOT NULL,
        ACTIVATED	BOOL   DEFAULT 0 NOT NULL,
        REMARKS	VARCHAR(255),
CONSTRAINT PK_COURSE PRIMARY KEY (ID)
);

/* Table: DAYS, Owner: SYSDBA */
CREATE TABLE DAYS 
(
        ID	INTEGER NOT NULL,
        COURSE_ID	INTEGER NOT NULL,
        APPLY_DATE	DATE NOT NULL,
        ACTIVATED	BOOL  DEFAULT 0 NOT NULL,
        REMARKS	VARCHAR(255),
CONSTRAINT PK_DAYS PRIMARY KEY (ID)
);

/* Table: DAYTIMES, Owner: SYSDBA */
CREATE TABLE DAYTIMES 
(
        DAYS_ID	INTEGER NOT NULL,
        TIME_SEQ	INTEGER NOT NULL,
        SUBJECT_ID	INTEGER NOT NULL,
        SUBJECT_CONTENTS_SEQ	INTEGER,
        REMARKS	VARCHAR(255),
CONSTRAINT PK_DAYTIMES PRIMARY KEY (DAYS_ID, TIME_SEQ)
);

/* Table: DUAL, Owner: SYSDBA */
CREATE TABLE DUAL 
(
        X	CHAR(1)
);

/* Table: EDU_TYPE, Owner: SYSDBA */
CREATE TABLE EDU_TYPE 
(
        ID	SMALLINT NOT NULL,
        NAME	VARCHAR(40) NOT NULL,
CONSTRAINT PK_EDU_TYPE PRIMARY KEY (ID)
);

/* Table: SUBJECT, Owner: SYSDBA */
CREATE TABLE SUBJECT 
(
        ID	INTEGER NOT NULL,
        NAME	VARCHAR(40) NOT NULL,
        EDU_TYPE_ID	SMALLINT DEFAULT 0 NOT NULL,
        SUBJECT_CATEGORY_ID	INTEGER DEFAULT 0 NOT NULL,
        COURSE_ID	INTEGER DEFAULT 0 NOT NULL,
        TEACHER_ID	INTEGER DEFAULT 0 NOT NULL,
        TIMES	INTEGER DEFAULT 0 NOT NULL,
        SUMMARY	VARCHAR(255),
        RELATIVE_LEVEL	VARCHAR(2),
        ACTIVATED	BOOL   DEFAULT 0 NOT NULL,
        REMARKS	VARCHAR(255),
CONSTRAINT PK_SUBJECT PRIMARY KEY (ID)
);

/* Table: SUBJECT_CATEGORY, Owner: SYSDBA */
CREATE TABLE SUBJECT_CATEGORY 
(
        ID	INTEGER NOT NULL,
        NAME	VARCHAR(40) NOT NULL,
        ACTIVATED	BOOL   DEFAULT 0 NOT NULL,
        REMARKS	VARCHAR(255),
CONSTRAINT PK_SUBJECT_CATEGORY PRIMARY KEY (ID)
);

/* Table: SUBJECT_CONTENTS, Owner: SYSDBA */
CREATE TABLE SUBJECT_CONTENTS 
(
        SUBJECT_ID	INTEGER NOT NULL,
        SEQ	INTEGER NOT NULL,
        SUMMARY	VARCHAR(255),
        CONTENT	VARCHAR(255),
CONSTRAINT PK_SUBJECT_CONTENTS PRIMARY KEY (SUBJECT_ID, SEQ)
);

/* Table: TEACHER, Owner: SYSDBA */
CREATE TABLE TEACHER 
(
        ID	SMALLINT NOT NULL,
        NAME	VARCHAR(40) NOT NULL,
        ALIAS	VARCHAR(20),
        REMARKS	VARCHAR(255),
        ACTIVATED	BOOL  DEFAULT 0 NOT NULL,
CONSTRAINT PK_TEACHER PRIMARY KEY (ID)
);

/* Table: TEXT_TABLE, Owner: SYSDBA */
CREATE TABLE TEXT_TABLE 
(
        COL1	CHAR(20),
        COL2	VARCHAR(20)
);

/* Table: TIMETABLE_DETAIL, Owner: SYSDBA */
CREATE TABLE TIMETABLE_DETAIL 
(
        TIMETABLE_MASTER_ID	INTEGER NOT NULL,
        TIME_SEQ	INTEGER NOT NULL,
        APPLY_TIME	TIME NOT NULL,
        SUB_MON	INTEGER,
        SUB_SEQ_MON	INTEGER,
        SUB_TUE	INTEGER,
        SUB_SEQ_TUE	INTEGER,
        SUB_WED	INTEGER,
        SUB_SEQ_WED	INTEGER,
        SUB_THU	INTEGER,
        SUB_SEQ_THU	INTEGER,
        SUB_FRI	INTEGER,
        SUB_SEQ_FRI	INTEGER,
        SUB_SAT	INTEGER,
        SUB_SEQ_SAT	INTEGER,
CONSTRAINT PK_TIMETABLE_DETAIL PRIMARY KEY (TIMETABLE_MASTER_ID, TIME_SEQ)
);

/* Table: TIMETABLE_MASTER, Owner: SYSDBA */
CREATE TABLE TIMETABLE_MASTER 
(
        ID	INTEGER NOT NULL,
        COURSE_ID	INTEGER NOT NULL,
        N_WEEK	INTEGER NOT NULL,
        MON	DATE,
        TUE	DATE,
        WED	DATE,
        THU	DATE,
        FRI	DATE,
        SAT	DATE,
CONSTRAINT PK_TIMETABLE_MASTER PRIMARY KEY (ID)
);
ALTER TABLE DAYS ADD CONSTRAINT PK_DAYS_COURSE FOREIGN KEY (COURSE_ID) REFERENCES COURSE (ID);
ALTER TABLE DAYTIMES ADD CONSTRAINT FK_DAYTIMES_DAYS FOREIGN KEY (DAYS_ID) REFERENCES DAYS (ID);
ALTER TABLE DAYTIMES ADD CONSTRAINT FK_DAYTIMES_SUBJECT FOREIGN KEY (SUBJECT_ID) REFERENCES SUBJECT (ID);
ALTER TABLE SUBJECT ADD CONSTRAINT FK_SUBJECT_COURSE FOREIGN KEY (COURSE_ID) REFERENCES COURSE (ID);
ALTER TABLE SUBJECT ADD CONSTRAINT FK_SUBJECT_EDU_TYPE FOREIGN KEY (EDU_TYPE_ID) REFERENCES EDU_TYPE (ID);
ALTER TABLE SUBJECT ADD CONSTRAINT FK_SUBJECT_SUBJECT_CATEGORY FOREIGN KEY (SUBJECT_CATEGORY_ID) REFERENCES SUBJECT_CATEGORY (ID);
ALTER TABLE SUBJECT ADD CONSTRAINT FK_SUBJECT_TEACHER FOREIGN KEY (TEACHER_ID) REFERENCES TEACHER (ID);
ALTER TABLE SUBJECT_CONTENTS ADD CONSTRAINT FK_SUBJECT_CONTENTS_SUBJECT FOREIGN KEY (SUBJECT_ID) REFERENCES SUBJECT (ID);
ALTER TABLE TIMETABLE_DETAIL ADD CONSTRAINT FK_TIMETABLE_DETAIL_M FOREIGN KEY (TIMETABLE_MASTER_ID) REFERENCES TIMETABLE_MASTER (ID);
ALTER TABLE TIMETABLE_MASTER ADD CONSTRAINT FK_TIMETABLE_MASTER_COURSE FOREIGN KEY (COURSE_ID) REFERENCES COURSE (ID);


/* View: SC_NAME, Owner: SYSDBA */
CREATE VIEW SC_NAME (
  SUBJECT_ID, 
  SC_SEQ, 
  SUBJECT_NAME, 
  SC_SUMMARY, 
  TEACHER_ALIAS
) 
AS
SELECT SC.SUBJECT_ID, SC.SEQ AS SC_SEQ, S.NAME || ' (' || E.NAME || ')' AS SUBJECT_NAME,
            SC.SUMMARY AS SC_SUMMARY, T.ALIAS AS TEACHER_ALIAS
        FROM SUBJECT_CONTENTS SC
            INNER JOIN SUBJECT S ON SC.SUBJECT_ID = S.ID
            INNER JOIN EDU_TYPE E ON S.EDU_TYPE_ID = E.ID
            INNER JOIN TEACHER T ON S.TEACHER_ID = T.ID
;
COMMIT WORK;

/* Stored procedures */

CREATE PROCEDURE P 
(
  F INTEGER
)
RETURNS
(
  R INTEGER
)
AS
BEGIN EXIT; END ;

CREATE PROCEDURE P1 
(
  X INTEGER,
  Y INTEGER
)
RETURNS
(
  Z INTEGER
)
AS
BEGIN EXIT; END ;

CREATE PROCEDURE SP_ASSIGN_SUB_SEQ 
(
  COURSE_ID INTEGER
)
AS
BEGIN EXIT; END ;

CREATE PROCEDURE SP_MAKE_TIMETABLE 
(
  COURSE_ID INTEGER,
  START_TIME TIME
)
AS
BEGIN EXIT; END ;

CREATE PROCEDURE SP_MAKE_TIMETABLE_DETAIL 
(
  MASTER_ID INTEGER,
  COURSE_ID INTEGER,
  N_WEEK INTEGER,
  MON DATE,
  TUE DATE,
  WED DATE,
  THU DATE,
  FRI DATE,
  SAT DATE,
  START_TIME TIME
)
AS
BEGIN EXIT; END ;


ALTER PROCEDURE P 
(
  F INTEGER
)
RETURNS
(
  R INTEGER
)
AS
begin
    r = 0;
    while ( r < f) do
    begin
        r = r + 1;
        suspend;
    end
end;

ALTER PROCEDURE P1 
(
  X INTEGER,
  Y INTEGER
)
RETURNS
(
  Z INTEGER
)
AS
begin
    z = x * y;
    suspend;
end;

ALTER PROCEDURE SP_ASSIGN_SUB_SEQ 
(
  COURSE_ID INTEGER
)
AS
DECLARE VARIABLE SUB_SEQ INTEGER;
    DECLARE VARIABLE DAYS_ID INTEGER;
    DECLARE VARIABLE SUBJECT_ID INTEGER;
    DECLARE VARIABLE TIME_SEQ INTEGER;
    DECLARE VARIABLE SAVE_SUBJECT_ID INTEGER;
BEGIN
    SAVE_SUBJECT_ID = -1;
    FOR
        SELECT DT.DAYS_ID, DT.SUBJECT_ID, DT.TIME_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE D.COURSE_ID = :COURSE_ID
            ORDER BY DT.SUBJECT_ID, DT.DAYS_ID, DT.TIME_SEQ
            INTO :DAYS_ID, :SUBJECT_ID, :TIME_SEQ
    DO
    BEGIN
        IF (SAVE_SUBJECT_ID != SUBJECT_ID) THEN
        BEGIN
            SUB_SEQ = 1;
            SAVE_SUBJECT_ID = SUBJECT_ID;
        END
        UPDATE DAYTIMES
            SET SUBJECT_CONTENTS_SEQ = :SUB_SEQ
            WHERE DAYS_ID = :DAYS_ID AND TIME_SEQ = :TIME_SEQ;
        SUB_SEQ = SUB_SEQ + 1;
    END
    SUSPEND;
END;

ALTER PROCEDURE SP_MAKE_TIMETABLE 
(
  COURSE_ID INTEGER,
  START_TIME TIME
)
AS
DECLARE VARIABLE MASTER_ID INTEGER;
    DECLARE VARIABLE N_WEEK INTEGER;
    DECLARE VARIABLE N_MONTH INTEGER;
    DECLARE VARIABLE TEMP_DATE DATE;
    DECLARE VARIABLE N_WEEKDAY INTEGER;
    DECLARE VARIABLE SUN DATE;
    DECLARE VARIABLE MON DATE;
    DECLARE VARIABLE TUE DATE;
    DECLARE VARIABLE WED DATE;
    DECLARE VARIABLE THU DATE;
    DECLARE VARIABLE FRI DATE;
    DECLARE VARIABLE SAT DATE;
    DECLARE VARIABLE INSERTED INTEGER;
BEGIN
    SELECT EXTRACT(MONTH FROM MIN(APPLY_DATE))
        FROM DAYS
        WHERE COURSE_ID = :COURSE_ID INTO N_MONTH;
    SELECT MAX(ID) FROM TIMETABLE_MASTER INTO :MASTER_ID;
    IF (MASTER_ID IS NULL) THEN
        MASTER_ID = 1;
    N_WEEK = 1;
    FOR SELECT APPLY_DATE
            FROM DAYS
            WHERE COURSE_ID = :COURSE_ID
            ORDER BY APPLY_DATE
            INTO :TEMP_DATE
    DO
    BEGIN
        INSERTED = 0;
        IF (EXTRACT(MONTH FROM TEMP_DATE) != N_MONTH) THEN
        BEGIN
            EXECUTE PROCEDURE SP_MAKE_TIMETABLE_DETAIL (:MASTER_ID, :COURSE_ID, :N_WEEK,
                :MON, :TUE, :WED, :THU, :FRI, :SAT, :START_TIME);
        /*
            INSERT INTO TIMETABLE_MASTER (ID, COURSE_ID, N_WEEK, MON, TUE, WED, THU, FRI, SAT)
                VALUES (:MASTER_ID, :COURSE_ID, :N_WEEK, :MON, :TUE, :WED, :THU, :FRI, :SAT);
        */
            N_MONTH = EXTRACT(MONTH FROM TEMP_DATE);
            N_WEEK = 1;
            MASTER_ID = MASTER_ID + 1;
            SUN = NULL;
            MON = NULL;
            TUE = NULL;
            WED = NULL;
            THU = NULL;
            FRI = NULL;
            SAT = NULL;
        END
        N_WEEKDAY = EXTRACT(WEEKDAY FROM TEMP_DATE);
        IF (N_WEEKDAY = 0) THEN
            SUN = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 1) THEN
            MON = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 2) THEN
            TUE = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 3) THEN
            WED = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 4) THEN
            THU = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 5) THEN
            FRI = TEMP_DATE;
        ELSE  /* SAT */
        BEGIN
            SAT = TEMP_DATE;
            EXECUTE PROCEDURE SP_MAKE_TIMETABLE_DETAIL (:MASTER_ID, :COURSE_ID, :N_WEEK,
                :MON, :TUE, :WED, :THU, :FRI, :SAT, :START_TIME);
            /*
            INSERT INTO TIMETABLE_MASTER (ID, COURSE_ID, N_WEEK, MON, TUE, WED, THU, FRI, SAT)
                VALUES (:MASTER_ID, :COURSE_ID, :N_WEEK, :MON, :TUE, :WED, :THU, :FRI, :SAT);
            */
            N_WEEK = N_WEEK + 1;
            MASTER_ID = MASTER_ID + 1;
            SUN = NULL;
            MON = NULL;
            TUE = NULL;
            WED = NULL;
            THU = NULL;
            FRI = NULL;
            SAT = NULL;
            INSERTED = 1;
        END
    END
    IF (INSERTED = 0) THEN
        EXECUTE PROCEDURE SP_MAKE_TIMETABLE_DETAIL (:MASTER_ID, :COURSE_ID, :N_WEEK,
                :MON, :TUE, :WED, :THU, :FRI, :SAT, :START_TIME);
/*
        INSERT INTO TIMETABLE_MASTER (ID, COURSE_ID, N_WEEK, MON, TUE, WED, THU, FRI, SAT)
            VALUES (:MASTER_ID, :COURSE_ID, :N_WEEK, :MON, :TUE, :WED, :THU, :FRI, :SAT);
*/
END;

ALTER PROCEDURE SP_MAKE_TIMETABLE_DETAIL 
(
  MASTER_ID INTEGER,
  COURSE_ID INTEGER,
  N_WEEK INTEGER,
  MON DATE,
  TUE DATE,
  WED DATE,
  THU DATE,
  FRI DATE,
  SAT DATE,
  START_TIME TIME
)
AS
DECLARE VARIABLE SUB_MON INTEGER;
    DECLARE VARIABLE SUB_TUE INTEGER;
    DECLARE VARIABLE SUB_WED INTEGER;
    DECLARE VARIABLE SUB_THU INTEGER;
    DECLARE VARIABLE SUB_FRI INTEGER;
    DECLARE VARIABLE SUB_SAT INTEGER;
    DECLARE VARIABLE SUB_SEQ_MON INTEGER;
    DECLARE VARIABLE SUB_SEQ_TUE INTEGER;
    DECLARE VARIABLE SUB_SEQ_WED INTEGER;
    DECLARE VARIABLE SUB_SEQ_THU INTEGER;
    DECLARE VARIABLE SUB_SEQ_FRI INTEGER;
    DECLARE VARIABLE SUB_SEQ_SAT INTEGER;
    DECLARE VARIABLE TIME_SEQ INTEGER;
    DECLARE VARIABLE MAX_TIME_SEQ INTEGER;
    DECLARE VARIABLE APPLY_TIME TIME;
BEGIN
    INSERT INTO TIMETABLE_MASTER (ID, COURSE_ID, N_WEEK, MON, TUE, WED, THU, FRI, SAT)
        VALUES (:MASTER_ID, :COURSE_ID, :N_WEEK, :MON, :TUE, :WED, :THU, :FRI, :SAT);
    SELECT MAX(TIME_SEQ)
        FROM DAYTIMES DT
            INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
        WHERE
            D.COURSE_ID = :COURSE_ID
        INTO :MAX_TIME_SEQ;
    TIME_SEQ = 1;
    APPLY_TIME = START_TIME;
    WHILE (TIME_SEQ <= MAX_TIME_SEQ) DO
    BEGIN
        SUB_MON = NULL;
        SUB_SEQ_MON = NULL;
        SUB_TUE = NULL;
        SUB_SEQ_TUE = NULL;
        SUB_WED = NULL;
        SUB_SEQ_WED = NULL;
        SUB_THU = NULL;
        SUB_SEQ_TUE = NULL;
        SUB_FRI = NULL;
        SUB_SEQ_FRI = NULL;
        SUB_SAT = NULL;
        SUB_SEQ_SAT = NULL;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :MON AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_MON, :SUB_SEQ_MON;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :TUE AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_TUE, :SUB_SEQ_TUE;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :WED AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_WED, :SUB_SEQ_WED;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :THU AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_THU, :SUB_SEQ_THU;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :FRI AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_FRI, :SUB_SEQ_FRI;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :SAT AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_SAT, :SUB_SEQ_SAT;
        INSERT INTO TIMETABLE_DETAIL (TIMETABLE_MASTER_ID, TIME_SEQ, APPLY_TIME,
                SUB_MON, SUB_SEQ_MON, SUB_TUE, SUB_SEQ_TUE, SUB_WED, SUB_SEQ_WED,
                SUB_THU, SUB_SEQ_THU, SUB_FRI, SUB_SEQ_FRI, SUB_SAT, SUB_SEQ_SAT )
            VALUES (:MASTER_ID, :TIME_SEQ, :APPLY_TIME,
                :SUB_MON, :SUB_SEQ_MON, :SUB_TUE, :SUB_SEQ_TUE, :SUB_WED, :SUB_SEQ_WED,
                :SUB_THU, :SUB_SEQ_THU, :SUB_FRI, :SUB_SEQ_FRI, :SUB_SAT, :SUB_SEQ_SAT );
        TIME_SEQ = TIME_SEQ + 1;
        APPLY_TIME = APPLY_TIME + 3600;
        IF (EXTRACT(HOUR FROM APPLY_TIME) = 12) THEN
            APPLY_TIME = APPLY_TIME + 3600;
    END
    SUSPEND;
END;
COMMIT WORK;

/* Grant Roles for this database */


/* Grant permissions for this database */


/* Meta data descriptions.  This syntax requires InterBase 2020 or higher.  Some tables require ODS18 and higher */
