/*
 * 2025-05-07 수
 */

DROP TABLE COURSE;
DROP TABLE DAYS;
DROP TABLE DAYTIMES;
DROP TABLE EDU_TYPE;
DROP TABLE TEACHER;
DROP TABLE SUBJECT_CATEGORY;
DROP TABLE SUBJECT;
DROP TABLE SUBJECT_CONTENTS;
DROP TABLE TIMETABLE_MASTER;
DROP TABLE TIMETABLE_DETAIL;
DROP TABLE DUAL;
DROP TABLE TEXT_TABLE;

DROP DOMAIN BOOL;
DROP DOMAIN LONGLONG;

CREATE DOMAIN BOOL AS SMALLINT DEFAULT 0;

CREATE DOMAIN LONGLONG AS DECIMAL(18, 0);

CREATE TABLE
    COURSE (
        ID INTEGER NOT NULL,
        NAME VARCHAR(60) NOT NULL,
        BEGIN_DATE DATE NOT NULL,
        END_DATE DATE NOT NULL,
        ACTIVATED BOOL DEFAULT 0 NOT NULL,
        REMARKS VARCHAR(750)
    );

CREATE TABLE
    DAYS (
        ID INTEGER NOT NULL,
        COURSE_ID INTEGER NOT NULL,
        APPLY_DATE DATE NOT NULL,
        ACTIVATED BOOL DEFAULT 0 NOT NULL,
        REMARKS VARCHAR(750)
    );

CREATE TABLE
    DAYTIMES (
        DAYS_ID INTEGER NOT NULL,
        TIME_SEQ INTEGER NOT NULL,
        SUBJECT_ID INTEGER NOT NULL,
        SUBJECT_CONTENTS_SEQ INTEGER,
        REMARKS VARCHAR(750)
    );

CREATE TABLE
    EDU_TYPE (
        ID SMALLINT NOT NULL,
        NAME VARCHAR(60) NOT NULL
    );

CREATE TABLE
    TEACHER (
        ID SMALLINT NOT NULL,
        NAME VARCHAR(60) NOT NULL,
        ALIAS VARCHAR(60),
        REMARKS VARCHAR(750),
        ACTIVATED BOOL DEFAULT 0 NOT NULL
    );

CREATE TABLE
    SUBJECT_CATEGORY (
        ID INTEGER NOT NULL,
        NAME VARCHAR(60) NOT NULL,
        ACTIVATED BOOL DEFAULT 0 NOT NULL,
        REMARKS VARCHAR(750)
    );

CREATE TABLE
    SUBJECT (
        ID INTEGER NOT NULL,
        NAME VARCHAR(60) NOT NULL,
        EDU_TYPE_ID SMALLINT DEFAULT 0 NOT NULL,
        SUBJECT_CATEGORY_ID INTEGER DEFAULT 0 NOT NULL,
        COURSE_ID INTEGER DEFAULT 0 NOT NULL,
        TEACHER_ID INTEGER DEFAULT 0 NOT NULL,
        TIMES INTEGER DEFAULT 0 NOT NULL,
        SUMMARY VARCHAR(750),
        RELATIVE_LEVEL VARCHAR(60),
        ACTIVATED BOOL DEFAULT 0 NOT NULL,
        REMARKS VARCHAR(750)
    );

CREATE TABLE
    SUBJECT_CONTENTS (
        SUBJECT_ID INTEGER NOT NULL,
        SEQ INTEGER NOT NULL,
        SUMMARY VARCHAR(750),
        CONTENT VARCHAR(750)
    );

CREATE TABLE
    TIMETABLE_MASTER (
        ID INTEGER NOT NULL,
        COURSE_ID INTEGER NOT NULL,
        N_WEEK INTEGER NOT NULL,
        MON DATE,
        TUE DATE,
        WED DATE,
        THU DATE,
        FRI DATE,
        SAT DATE
    );

CREATE TABLE
    TIMETABLE_DETAIL (
        TIMETABLE_MASTER_ID INTEGER NOT NULL,
        TIME_SEQ INTEGER NOT NULL,
        APPLY_TIME TIME NOT NULL,
        SUB_MON INTEGER,
        SUB_SEQ_MON INTEGER,
        SUB_TUE INTEGER,
        SUB_SEQ_TUE INTEGER,
        SUB_WED INTEGER,
        SUB_SEQ_WED INTEGER,
        SUB_THU INTEGER,
        SUB_SEQ_THU INTEGER,
        SUB_FRI INTEGER,
        SUB_SEQ_FRI INTEGER,
        SUB_SAT INTEGER,
        SUB_SEQ_SAT INTEGER
    );

CREATE TABLE
    DUAL (X CHAR(1));

CREATE TABLE
    TEXT_TABLE (COL1 CHAR(20), COL2 VARCHAR(60));
