/*
 * 2025-05-07 수
 */

/*
DROP PROCEDURE P;
DROP PROCEDURE P1;
DROP PROCEDURE SP_ASSIGN_SUB_SEQ;

COMMIT;
*/
COMMIT WORK;
SET TERM ^ ;

CREATE PROCEDURE P
(
    F INTEGER
)
RETURNS
(
    R INTEGER
)
AS
BEGIN
    R = 0;
    WHILE ( R < F) DO
    BEGIN
        R = R + 1;
        SUSPEND;
    END
END^
SET TERM ; ^
COMMIT WORK;

COMMIT WORK;
SET TERM ^ ;

CREATE PROCEDURE P1
(
    X INTEGER,
    Y INTEGER
)
RETURNS
(
    Z INTEGER
)
AS
BEGIN
    Z = X * Y;
    SUSPEND;
END^
SET TERM ; ^
COMMIT WORK;

COMMIT WORK;
SET TERM ^ ;

CREATE PROCEDURE SP_ASSIGN_SUB_SEQ
(
    COURSE_ID INTEGER
)
AS
    DECLARE VARIABLE SUB_SEQ INTEGER;
    DECLARE VARIABLE DAYS_ID INTEGER;
    DECLARE VARIABLE SUBJECT_ID INTEGER;
    DECLARE VARIABLE TIME_SEQ INTEGER;
    DECLARE VARIABLE SAVE_SUBJECT_ID INTEGER;
BEGIN
    SAVE_SUBJECT_ID = -1;
    FOR
        SELECT DT.DAYS_ID, DT.SUBJECT_ID, DT.TIME_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE D.COURSE_ID = :COURSE_ID
            ORDER BY DT.SUBJECT_ID, DT.DAYS_ID, DT.TIME_SEQ
            INTO :DAYS_ID, :SUBJECT_ID, :TIME_SEQ
    DO
    BEGIN
        IF (SAVE_SUBJECT_ID != SUBJECT_ID) THEN
        BEGIN
            SUB_SEQ = 1;
            SAVE_SUBJECT_ID = SUBJECT_ID;
        END
        UPDATE DAYTIMES
            SET SUBJECT_CONTENTS_SEQ = :SUB_SEQ
            WHERE DAYS_ID = :DAYS_ID AND TIME_SEQ = :TIME_SEQ;
        SUB_SEQ = SUB_SEQ + 1;
    END
    SUSPEND;
END^
SET TERM ; ^
COMMIT WORK;

COMMIT WORK;
SET TERM ^ ;

CREATE PROCEDURE SP_MAKE_TIMETABLE
(
    COURSE_ID INTEGER,
    START_TIME TIME
)
AS
    DECLARE VARIABLE MASTER_ID INTEGER;
    DECLARE VARIABLE N_WEEK INTEGER;
    DECLARE VARIABLE N_MONTH INTEGER;
    DECLARE VARIABLE TEMP_DATE DATE;
    DECLARE VARIABLE N_WEEKDAY INTEGER;
    DECLARE VARIABLE SUN DATE;
    DECLARE VARIABLE MON DATE;
    DECLARE VARIABLE TUE DATE;
    DECLARE VARIABLE WED DATE;
    DECLARE VARIABLE THU DATE;
    DECLARE VARIABLE FRI DATE;
    DECLARE VARIABLE SAT DATE;
    DECLARE VARIABLE INSERTED INTEGER;
BEGIN
    SELECT EXTRACT(MONTH FROM MIN(APPLY_DATE))
        FROM DAYS
        WHERE COURSE_ID = :COURSE_ID INTO N_MONTH;
    SELECT MAX(ID) FROM TIMETABLE_MASTER INTO :MASTER_ID;
    IF (MASTER_ID IS NULL) THEN
        MASTER_ID = 1;
    N_WEEK = 1;
    FOR SELECT APPLY_DATE
            FROM DAYS
            WHERE COURSE_ID = :COURSE_ID
            ORDER BY APPLY_DATE
            INTO :TEMP_DATE
    DO
    BEGIN
        INSERTED = 0;
        IF (EXTRACT(MONTH FROM TEMP_DATE) != N_MONTH) THEN
        BEGIN
            EXECUTE PROCEDURE SP_MAKE_TIMETABLE_DETAIL (:MASTER_ID, :COURSE_ID, :N_WEEK,
                :MON, :TUE, :WED, :THU, :FRI, :SAT, :START_TIME);
        /*
            INSERT INTO TIMETABLE_MASTER (ID, COURSE_ID, N_WEEK, MON, TUE, WED, THU, FRI, SAT)
                VALUES (:MASTER_ID, :COURSE_ID, :N_WEEK, :MON, :TUE, :WED, :THU, :FRI, :SAT);
        */
            N_MONTH = EXTRACT(MONTH FROM TEMP_DATE);
            N_WEEK = 1;
            MASTER_ID = MASTER_ID + 1;
            SUN = NULL;
            MON = NULL;
            TUE = NULL;
            WED = NULL;
            THU = NULL;
            FRI = NULL;
            SAT = NULL;
        END
        N_WEEKDAY = EXTRACT(WEEKDAY FROM TEMP_DATE);
        IF (N_WEEKDAY = 0) THEN
            SUN = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 1) THEN
            MON = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 2) THEN
            TUE = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 3) THEN
            WED = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 4) THEN
            THU = TEMP_DATE;
        ELSE IF (N_WEEKDAY = 5) THEN
            FRI = TEMP_DATE;
        ELSE  /* SAT */
        BEGIN
            SAT = TEMP_DATE;
            EXECUTE PROCEDURE SP_MAKE_TIMETABLE_DETAIL (:MASTER_ID, :COURSE_ID, :N_WEEK,
                :MON, :TUE, :WED, :THU, :FRI, :SAT, :START_TIME);
            /*
            INSERT INTO TIMETABLE_MASTER (ID, COURSE_ID, N_WEEK, MON, TUE, WED, THU, FRI, SAT)
                VALUES (:MASTER_ID, :COURSE_ID, :N_WEEK, :MON, :TUE, :WED, :THU, :FRI, :SAT);
            */
            N_WEEK = N_WEEK + 1;
            MASTER_ID = MASTER_ID + 1;
            SUN = NULL;
            MON = NULL;
            TUE = NULL;
            WED = NULL;
            THU = NULL;
            FRI = NULL;
            SAT = NULL;
            INSERTED = 1;
        END
    END
    IF (INSERTED = 0) THEN
        EXECUTE PROCEDURE SP_MAKE_TIMETABLE_DETAIL (:MASTER_ID, :COURSE_ID, :N_WEEK,
                :MON, :TUE, :WED, :THU, :FRI, :SAT, :START_TIME);
/*
        INSERT INTO TIMETABLE_MASTER (ID, COURSE_ID, N_WEEK, MON, TUE, WED, THU, FRI, SAT)
            VALUES (:MASTER_ID, :COURSE_ID, :N_WEEK, :MON, :TUE, :WED, :THU, :FRI, :SAT);
*/
END^
SET TERM ; ^
COMMIT WORK;

COMMIT WORK;
SET TERM ^ ;

CREATE PROCEDURE SP_MAKE_TIMETABLE_DETAIL 
(
  MASTER_ID INTEGER,
  COURSE_ID INTEGER,
  N_WEEK INTEGER,
  MON DATE,
  TUE DATE,
  WED DATE,
  THU DATE,
  FRI DATE,
  SAT DATE,
  START_TIME TIME
)
AS
    DECLARE VARIABLE SUB_MON INTEGER;
    DECLARE VARIABLE SUB_TUE INTEGER;
    DECLARE VARIABLE SUB_WED INTEGER;
    DECLARE VARIABLE SUB_THU INTEGER;
    DECLARE VARIABLE SUB_FRI INTEGER;
    DECLARE VARIABLE SUB_SAT INTEGER;
    DECLARE VARIABLE SUB_SEQ_MON INTEGER;
    DECLARE VARIABLE SUB_SEQ_TUE INTEGER;
    DECLARE VARIABLE SUB_SEQ_WED INTEGER;
    DECLARE VARIABLE SUB_SEQ_THU INTEGER;
    DECLARE VARIABLE SUB_SEQ_FRI INTEGER;
    DECLARE VARIABLE SUB_SEQ_SAT INTEGER;
    DECLARE VARIABLE TIME_SEQ INTEGER;
    DECLARE VARIABLE MAX_TIME_SEQ INTEGER;
    DECLARE VARIABLE APPLY_TIME TIME;
BEGIN
    INSERT INTO TIMETABLE_MASTER (ID, COURSE_ID, N_WEEK, MON, TUE, WED, THU, FRI, SAT)
        VALUES (:MASTER_ID, :COURSE_ID, :N_WEEK, :MON, :TUE, :WED, :THU, :FRI, :SAT);
    SELECT MAX(TIME_SEQ)
        FROM DAYTIMES DT
            INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
        WHERE
            D.COURSE_ID = :COURSE_ID
        INTO :MAX_TIME_SEQ;
    TIME_SEQ = 1;
    APPLY_TIME = START_TIME;
    WHILE (TIME_SEQ <= MAX_TIME_SEQ) DO
    BEGIN
        SUB_MON = NULL;
        SUB_SEQ_MON = NULL;
        SUB_TUE = NULL;
        SUB_SEQ_TUE = NULL;
        SUB_WED = NULL;
        SUB_SEQ_WED = NULL;
        SUB_THU = NULL;
        SUB_SEQ_TUE = NULL;
        SUB_FRI = NULL;
        SUB_SEQ_FRI = NULL;
        SUB_SAT = NULL;
        SUB_SEQ_SAT = NULL;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :MON AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_MON, :SUB_SEQ_MON;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :TUE AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_TUE, :SUB_SEQ_TUE;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :WED AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_WED, :SUB_SEQ_WED;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :THU AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_THU, :SUB_SEQ_THU;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :FRI AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_FRI, :SUB_SEQ_FRI;
        SELECT SUBJECT_ID, SUBJECT_CONTENTS_SEQ
            FROM DAYTIMES DT
                INNER JOIN DAYS D ON DT.DAYS_ID = D.ID
            WHERE
                D.COURSE_ID = :COURSE_ID AND D.APPLY_DATE = :SAT AND TIME_SEQ = :TIME_SEQ
            INTO :SUB_SAT, :SUB_SEQ_SAT;
        INSERT INTO TIMETABLE_DETAIL (TIMETABLE_MASTER_ID, TIME_SEQ, APPLY_TIME,
                SUB_MON, SUB_SEQ_MON, SUB_TUE, SUB_SEQ_TUE, SUB_WED, SUB_SEQ_WED,
                SUB_THU, SUB_SEQ_THU, SUB_FRI, SUB_SEQ_FRI, SUB_SAT, SUB_SEQ_SAT )
            VALUES (:MASTER_ID, :TIME_SEQ, :APPLY_TIME,
                :SUB_MON, :SUB_SEQ_MON, :SUB_TUE, :SUB_SEQ_TUE, :SUB_WED, :SUB_SEQ_WED,
                :SUB_THU, :SUB_SEQ_THU, :SUB_FRI, :SUB_SEQ_FRI, :SUB_SAT, :SUB_SEQ_SAT );
        TIME_SEQ = TIME_SEQ + 1;
        APPLY_TIME = APPLY_TIME + 3600;
        IF (EXTRACT(HOUR FROM APPLY_TIME) = 12) THEN
            APPLY_TIME = APPLY_TIME + 3600;
    END
    SUSPEND;
END^
SET TERM ; ^
COMMIT WORK;
