#ifndef __MAIN_H__
#define __MAIN_H__	20250508

#ifndef __DCL_ARGUMENTS_H__
#include <dcl/Arguments.h>
#endif

__DCL_BEGIN_NAMESPACE

class MainArguments : public Arguments
{
public:
	MainArguments(Writer& _output, Writer& _errout);

	virtual String toString() const;

	bool verbose() const {
		return __verbose;
	}

	const String& source() const {
		return __source;
	}

	const String& destination() const {
		return __destination;
	}

	const String& entities() const {
		return __entities;
	}

	bool truncate() const {
		return __truncate;
	}

	int rows() const {
		return __rows;
	}

	int i4precision() const {
		return __i4precision;
	}

	int i8precision() const {
		return __i8precision;
	}

	bool dryrun() const {
		return __dryrun;
	}

protected:
	virtual void onOption(int _key, const String& _arg)
		__DCL_THROWS1(Exception*);

	virtual String onValidate();

	bool		__dryrun;
	bool		__verbose;
	String		__source;
	String		__destination;
	String		__entities;
	bool		__truncate;
	int	__rows;
	int	__i4precision;
	int	__i8precision;
};

__DCL_END_NAMESPACE

#endif	// __MAIN_H__
